Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 4648)
@@ -710,46 +679,42 @@
 
           CALL MPI_BCAST( nx_a, 1, MPI_INTEGER, 0, comm2d, ierr)
-          CALL MPI_BCAST( ny_a, 1, MPI_INTEGER, 0, comm2d, ierr) 
-          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr) 
-
-       ENDIF
-  
+          CALL MPI_BCAST( ny_a, 1, MPI_INTEGER, 0, comm2d, ierr)
+          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr)
+
+       ENDIF
+
        ngp_a = ( nx_a+1 + 2 * nbgp ) * ( ny_a+1 + 2 * nbgp )
        ngp_o = ( nx_o+1 + 2 * nbgp ) * ( ny_o+1 + 2 * nbgp )
 
 !
-!--    Determine if the horizontal grid and the number of PEs in ocean and
-!--    atmosphere is same or not
-       IF ( nx_o == nx_a  .AND.  ny_o == ny_a  .AND.  &
-            pdims(1) == pdims_remote(1) .AND. pdims(2) == pdims_remote(2) ) &
-       THEN
+!--    Determine if the horizontal grid and the number of PEs in ocean and atmosphere is same or not.
+       IF ( nx_o == nx_a  .AND.  ny_o == ny_a  .AND.                                               &
+            pdims(1) == pdims_remote(1)  .AND.  pdims(2) == pdims_remote(2) )  THEN
           coupling_topology = 0
        ELSE
           coupling_topology = 1
-       ENDIF 
-
-!
-!--    Determine the target PEs for the exchange between ocean and
-!--    atmosphere (comm2d)
+       ENDIF
+
+!
+!--    Determine the target PEs for the exchange between ocean and atmosphere (comm2d)
        IF ( coupling_topology == 0 )  THEN
 !
-!--       In case of identical topologies, every atmosphere PE has exactly one
-!--       ocean PE counterpart and vice versa
-          IF ( TRIM( coupling_mode ) == 'atmosphere_to_ocean' ) THEN
+!--       In case of identical topologies, every atmosphere PE has exactly one ocean PE counterpart
+!--       and vice versa
+          IF ( TRIM( coupling_mode ) == 'atmosphere_to_ocean' )  THEN
              target_id = myid + numprocs
           ELSE
-             target_id = myid 
+             target_id = myid
           ENDIF
 
        ELSE
 !
-!--       In case of nonequivalent topology in ocean and atmosphere only for
-!--       PE0 in ocean and PE0 in atmosphere a target_id is needed, since
-!--       data echxchange between ocean and atmosphere will be done only
-!--       between these PEs.    
+!--       In case of nonequivalent topology in ocean and atmosphere only for PE0 in ocean and PE0 in
+!--       atmosphere a target_id is needed, since data echxchange between ocean and atmosphere will
+!--       be done only between these PEs.
           IF ( myid == 0 )  THEN
 
              IF ( TRIM( coupling_mode ) == 'atmosphere_to_ocean' )  THEN
-                target_id = numprocs 
+                target_id = numprocs
              ELSE
                 target_id = 0
@@ -765,6 +730,5 @@
 
 !
-!-- Array bounds when running on a single PE (respectively a non-parallel
-!-- machine)
+!-- Array bounds when running on a single PE (respectively a non-parallel machine)
     nxl = 0
     nxr = nx
@@ -784,6 +748,6 @@
 
 !
-!-- Array bounds for the pressure solver (in the parallel code, these bounds
-!-- are the ones for the transposed arrays)
+!-- Array bounds for the pressure solver (in the parallel code, these bounds are the ones for the
+!-- transposed arrays)
     nys_x = nys
     nyn_x = nyn
@@ -804,6 +768,6 @@
 
 !
-!-- Calculate number of grid levels necessary for the multigrid poisson solver
-!-- as well as the gridpoint indices on each level
+!-- Calculate number of grid levels necessary for the multigrid poisson solver as well as the
+!-- gridpoint indices on each level
     IF ( psolver(1:9) == 'multigrid' )  THEN
 
@@ -833,11 +797,9 @@
        ENDDO
 !
-!--    The optimized MG-solver does not allow odd values for nz at the coarsest
-!--    grid level
+!--    The optimized MG-solver does not allow odd values for nz at the coarsest grid level
        IF ( TRIM( psolver ) /= 'multigrid_noopt' )  THEN
           IF ( MOD( k, 2 ) /= 0 )  mg_levels_z = mg_levels_z - 1
 !
-!--       An odd value of nz does not work. The finest level must have an even
-!--       value.
+!--       An odd value of nz does not work. The finest level must have an even value.
           IF (  mg_levels_z == 0 )  THEN
              message_string = 'optimized multigrid method requires nz to be even'
@@ -847,20 +809,20 @@
 
        maximum_grid_level = MIN( mg_levels_x, mg_levels_y, mg_levels_z )
-!       
-!--    Check if subdomain sizes prevents any coarsening. 
-!--    This case, the maximum number of grid levels is 1, i.e. effectively 
-!--    a Gauss-Seidel scheme is applied rather than a multigrid approach.
+!
+!--    Check if subdomain sizes prevents any coarsening.
+!--    This case, the maximum number of grid levels is 1, i.e. effectively a Gauss-Seidel scheme is
+!--    applied rather than a multigrid approach.
 !--    Give a warning in this case.
        IF ( maximum_grid_level == 1  .AND.  mg_switch_to_pe0_level == -1 )  THEN
-          message_string = 'No grid coarsening possible, multigrid ' //        &
-                           'approach effectively reduces to a Gauss-Seidel ' //&
+          message_string = 'No grid coarsening possible, multigrid ' //                            &
+                           'approach effectively reduces to a Gauss-Seidel ' //                    &
                            'scheme.'
-          
+
           CALL message( 'poismg', 'PA0648', 0, 1, 0, 6, 0 )
        ENDIF
 
 !
-!--    Find out, if the total domain allows more levels. These additional
-!--    levels are identically processed on all PEs.
+!--    Find out, if the total domain allows more levels. These additional levels are identically
+!--    processed on all PEs.
        IF ( numprocs > 1  .AND.  mg_switch_to_pe0_level /= -1 )  THEN
 
@@ -887,6 +849,5 @@
 
              IF ( maximum_grid_level_l > mg_switch_to_pe0_level_l )  THEN
-                mg_switch_to_pe0_level_l = maximum_grid_level_l - &
-                                           mg_switch_to_pe0_level_l + 1
+                mg_switch_to_pe0_level_l = maximum_grid_level_l - mg_switch_to_pe0_level_l + 1
              ELSE
                 mg_switch_to_pe0_level_l = 0
@@ -901,6 +862,5 @@
 
 !
-!--       Use switch level calculated above only if it is not pre-defined
-!--       by user
+!--       Use switch level calculated above only if it is not pre-defined by user
           IF ( mg_switch_to_pe0_level == 0 )  THEN
              IF ( mg_switch_to_pe0_level_l /= 0 )  THEN
@@ -912,7 +872,7 @@
 !
 !--          Check pre-defined value and reset to default, if neccessary
-             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.      &
+             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.                          &
                   mg_switch_to_pe0_level >= maximum_grid_level_l )  THEN
-                message_string = 'mg_switch_to_pe0_level ' //                  &
+                message_string = 'mg_switch_to_pe0_level ' //                                      &
                                  'out of range and reset to 0'
                 CALL message( 'init_pegrid', 'PA0235', 0, 1, 0, 6, 0 )
@@ -920,6 +880,6 @@
              ELSE
 !
-!--             Use the largest number of possible levels anyway and recalculate
-!--             the switch level to this largest number of possible values
+!--             Use the largest number of possible levels anyway and recalculate the switch level to
+!--             this largest number of possible values
                 maximum_grid_level = maximum_grid_level_l
 
@@ -930,13 +890,13 @@
        ENDIF
 
-       ALLOCATE( grid_level_count(maximum_grid_level),                       &
-                 nxl_mg(0:maximum_grid_level), nxr_mg(0:maximum_grid_level), &
-                 nyn_mg(0:maximum_grid_level), nys_mg(0:maximum_grid_level), &
+       ALLOCATE( grid_level_count(maximum_grid_level),                                             &
+                 nxl_mg(0:maximum_grid_level), nxr_mg(0:maximum_grid_level),                       &
+                 nyn_mg(0:maximum_grid_level), nys_mg(0:maximum_grid_level),                       &
                  nzt_mg(0:maximum_grid_level) )
 
        grid_level_count = 0
 !
-!--    Index zero required as dummy due to definition of arrays f2 and p2 in
-!--    recursive subroutine next_mg_level
+!--    Index zero required as dummy due to definition of arrays f2 and p2 in recursive subroutine
+!--    next_mg_level
        nxl_mg(0) = 0; nxr_mg(0) = 0; nyn_mg(0) = 0; nys_mg(0) = 0; nzt_mg(0) = 0
 
@@ -948,6 +908,5 @@
 #if defined( __parallel )
 !
-!--          Save the grid size of the subdomain at the switch level, because
-!--          it is needed in poismg.
+!--          Save the grid size of the subdomain at the switch level, because it is needed in poismg.
              ind(1) = nxl_l; ind(2) = nxr_l
              ind(3) = nys_l; ind(4) = nyn_l
@@ -969,16 +928,14 @@
              nys_l = 0
 !
-!--          The size of this gathered array must not be larger than the
-!--          array tend, which is used in the multigrid scheme as a temporary
-!--          array. Therefore the subdomain size of an PE is calculated and 
-!--          the size of the gathered grid. These values are used in  
-!--          routines pres and poismg
-             subdomain_size = ( nxr - nxl + 2 * nbgp + 1 ) * &
+!--          The size of this gathered array must not be larger than the array tend, which is used
+!--          in the multigrid scheme as a temporary array. Therefore the subdomain size of an PE is
+!--          calculated and the size of the gathered grid. These values are used in routines pres
+!--          and poismg.
+             subdomain_size = ( nxr - nxl + 2 * nbgp + 1 ) *                                       &
                               ( nyn - nys + 2 * nbgp + 1 ) * ( nzt - nzb + 2 )
-             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) *  &
-                              ( nzt_l - nzb + 2 )
+             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) * ( nzt_l - nzb + 2 )
 
 #else
-             message_string = 'multigrid gather/scatter impossible ' //        &
+             message_string = 'multigrid gather/scatter impossible ' //                            &
                           'in non parallel mode'
              CALL message( 'init_pegrid', 'PA0237', 1, 2, 0, 6, 0 )
@@ -992,174 +949,4 @@
           nzt_mg(i) = nzt_l
 
-          nxl_l = nxl_l / 2 
-          nxr_l = nxr_l / 2
-          nys_l = nys_l / 2 
-          nyn_l = nyn_l / 2 
-          nzt_l = nzt_l / 2 
-          
-       ENDDO
-
-!
-!--    Temporary problem: Currently calculation of maxerror in routine poismg crashes
-!--    if grid data are collected on PE0 already on the finest grid level.
-!--    To be solved later.
-       IF ( maximum_grid_level == mg_switch_to_pe0_level )  THEN
-          message_string = 'grid coarsening on subdomain level cannot be performed'
-          CALL message( 'poismg', 'PA0236', 1, 2, 0, 6, 0 )
-       ENDIF
-
-    ELSE
-
-       maximum_grid_level = 0
-
-    ENDIF
-
-!
-!-- Default level 0 tells exchange_horiz that all ghost planes have to be
-!-- exchanged. grid_level is adjusted in poismg, where only one ghost plane
-!-- is required.
-    grid_level = 0
-
-#if defined( __parallel )
-!
-!-- Gridpoint number for the exchange of ghost points (y-line for 2D-arrays)
-    ngp_y  = nyn - nys + 1 + 2 * nbgp
-
-!
-!-- Define new MPI derived datatypes for the exchange of ghost points in
-!-- x- and y-direction for 2D-arrays (line)
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_REAL, type_x,     &
-                          ierr )
-    CALL MPI_TYPE_COMMIT( type_x, ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_REAL, type_y, ierr )
-    CALL MPI_TYPE_COMMIT( type_y, ierr )
-!
-!-- Define new MPI derived datatypes for the exchange of ghost points in
-!-- x- and y-direction for 2D-INTEGER arrays (line) - on normal grid.
-!-- Define types for 32-bit and 8-bit Integer. The 8-bit Integer are only 
-!-- required on normal grid, while 32-bit Integer may be also required on 
-!-- coarser grid level in case of multigrid solver.
-!
-!-- 8-bit Integer
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_BYTE,             &
-                          type_x_byte, ierr )
-    CALL MPI_TYPE_COMMIT( type_x_byte, ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_BYTE,                        &
-                          type_y_byte, ierr )
-    CALL MPI_TYPE_COMMIT( type_y_byte, ierr )
-!
-!-- 32-bit Integer
-    ALLOCATE( type_x_int(0:maximum_grid_level),                                &
-              type_y_int(0:maximum_grid_level) )
-              
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_INTEGER,          &
-                          type_x_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_x_int(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_INTEGER, type_y_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_y_int(0), ierr )
-!
-!-- Calculate gridpoint numbers for the exchange of ghost points along x
-!-- (yz-plane for 3D-arrays) and define MPI derived data type(s) for the
-!-- exchange of ghost points in y-direction (xz-plane).
-!-- Do these calculations for the model grid and (if necessary) also
-!-- for the coarser grid levels used in the multigrid method
-    ALLOCATE ( ngp_xz(0:maximum_grid_level),                                   &
-               ngp_xz_int(0:maximum_grid_level),                               &
-               ngp_yz(0:maximum_grid_level),                                   &
-               ngp_yz_int(0:maximum_grid_level),                               &
-               type_xz(0:maximum_grid_level),                                  &
-               type_xz_int(0:maximum_grid_level),                              &
-               type_yz(0:maximum_grid_level),                                  &
-               type_yz_int(0:maximum_grid_level) )
-
-    nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
-
-!
-!-- Discern between the model grid, which needs nbgp ghost points and
-!-- grid levels for the multigrid scheme. In the latter case only one
-!-- ghost point is necessary.
-!-- First definition of MPI-datatypes for exchange of ghost layers on normal 
-!-- grid. The following loop is needed for data exchange in poismg.f90.
-!
-!-- Determine number of grid points of yz-layer for exchange
-    ngp_yz(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
-
-!
-!-- Define an MPI-datatype for the exchange of left/right boundaries.
-!-- Although data are contiguous in physical memory (which does not
-!-- necessarily require an MPI-derived datatype), the data exchange between
-!-- left and right PE's using the MPI-derived type is 10% faster than without.
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz(0), &
-                          MPI_REAL, type_xz(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_xz(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz(0), ngp_yz(0), MPI_REAL, type_yz(0), &
-                          ierr ) 
-    CALL MPI_TYPE_COMMIT( type_yz(0), ierr )
-
-!
-!-- Define data types for exchange of 3D Integer arrays.
-    ngp_yz_int(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
-
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz_int(0),   &
-                          MPI_INTEGER, type_xz_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_xz_int(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz_int(0), ngp_yz_int(0), MPI_INTEGER,     &
-                          type_yz_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_yz_int(0), ierr )
-
-!
-!-- Definition of MPI-datatypes for multigrid method (coarser level grids)
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-!    
-!--    Definition of MPI-datatyoe as above, but only 1 ghost level is used
-       DO  i = maximum_grid_level, 1 , -1
-!
-!--       For 3D-exchange on different multigrid level, one ghost point for 
-!--       REAL arrays, two ghost points for INTEGER arrays
-          ngp_xz(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
-          ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
-
-          ngp_xz_int(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
-          ngp_yz_int(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
-!
-!--       MPI data type for REAL arrays, for xz-layers
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i),       &
-                                MPI_REAL, type_xz(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
-
-!
-!--       MPI data type for INTEGER arrays, for xz-layers
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz_int(i),   &
-                                MPI_INTEGER, type_xz_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_xz_int(i), ierr )
-
-!
-!--       MPI data type for REAL arrays, for yz-layers
-          CALL MPI_TYPE_VECTOR( 1, ngp_yz(i), ngp_yz(i), MPI_REAL, type_yz(i), &
-                                ierr )
-          CALL MPI_TYPE_COMMIT( type_yz(i), ierr )
-!
-!--       MPI data type for INTEGER arrays, for yz-layers
-          CALL MPI_TYPE_VECTOR( 1, ngp_yz_int(i), ngp_yz_int(i), MPI_INTEGER,  &
-                                type_yz_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_yz_int(i), ierr )
-
-
-!--       For 2D-exchange of INTEGER arrays on coarser grid level, where 2 ghost
-!--       points need to be exchanged. Only required for 32-bit Integer arrays.
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+5, 2, nyn_l-nys_l+5, MPI_INTEGER,  &
-                                type_x_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_x_int(i), ierr )
-
-
-          CALL MPI_TYPE_VECTOR( 2, nyn_l-nys_l+5, nyn_l-nys_l+5, MPI_INTEGER,  &
-                                type_y_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_y_int(i), ierr )
-
           nxl_l = nxl_l / 2
           nxr_l = nxr_l / 2
@@ -1170,4 +957,159 @@
        ENDDO
 
+!
+!--    Temporary problem: Currently calculation of maxerror in routine poismg crashes if grid data
+!--    are collected on PE0 already on the finest grid level.
+!--    To be solved later.
+       IF ( maximum_grid_level == mg_switch_to_pe0_level )  THEN
+          message_string = 'grid coarsening on subdomain level cannot be performed'
+          CALL message( 'poismg', 'PA0236', 1, 2, 0, 6, 0 )
+       ENDIF
+
+    ELSE
+
+       maximum_grid_level = 0
+
+    ENDIF
+
+!
+!-- Default level 0 tells exchange_horiz that all ghost planes have to be exchanged. grid_level is
+!-- adjusted in poismg, where only one ghost plane is required.
+    grid_level = 0
+
+#if defined( __parallel )
+!
+!-- Gridpoint number for the exchange of ghost points (y-line for 2D-arrays)
+    ngp_y  = nyn - nys + 1 + 2 * nbgp
+
+!
+!-- Define new MPI derived datatypes for the exchange of ghost points in x- and y-direction for
+!-- 2D-arrays (line)
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_REAL, type_x, ierr )
+    CALL MPI_TYPE_COMMIT( type_x, ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_REAL, type_y, ierr )
+    CALL MPI_TYPE_COMMIT( type_y, ierr )
+!
+!-- Define new MPI derived datatypes for the exchange of ghost points in x- and y-direction for
+!-- 2D-INTEGER arrays (line) - on normal grid.
+!-- Define types for 32-bit and 8-bit Integer. The 8-bit Integer are only required on normal grid,
+!-- while 32-bit Integer may be also required on coarser grid level in case of multigrid solver.
+!
+!-- 8-bit Integer
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_BYTE, type_x_byte, ierr )
+    CALL MPI_TYPE_COMMIT( type_x_byte, ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_BYTE, type_y_byte, ierr )
+    CALL MPI_TYPE_COMMIT( type_y_byte, ierr )
+!
+!-- 32-bit Integer
+    ALLOCATE( type_x_int(0:maximum_grid_level), type_y_int(0:maximum_grid_level) )
+
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_INTEGER, type_x_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_x_int(0), ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_INTEGER, type_y_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_y_int(0), ierr )
+!
+!-- Calculate gridpoint numbers for the exchange of ghost points along x (yz-plane for 3D-arrays)
+!-- and define MPI derived data type(s) for the exchange of ghost points in y-direction (xz-plane).
+!-- Do these calculations for the model grid and (if necessary) also for the coarser grid levels
+!-- used in the multigrid method
+    ALLOCATE ( ngp_xz(0:maximum_grid_level),                                                       &
+               ngp_xz_int(0:maximum_grid_level),                                                   &
+               ngp_yz(0:maximum_grid_level),                                                       &
+               ngp_yz_int(0:maximum_grid_level),                                                   &
+               type_xz(0:maximum_grid_level),                                                      &
+               type_xz_int(0:maximum_grid_level),                                                  &
+               type_yz(0:maximum_grid_level),                                                      &
+               type_yz_int(0:maximum_grid_level) )
+
+    nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
+
+!
+!-- Discern between the model grid, which needs nbgp ghost points and grid levels for the multigrid
+!-- scheme. In the latter case only one ghost point is necessary.
+!-- First definition of MPI-datatypes for exchange of ghost layers on normal grid. The following
+!-- loop is needed for data exchange in poismg.f90.
+!
+!-- Determine number of grid points of yz-layer for exchange
+    ngp_yz(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
+
+!
+!-- Define an MPI-datatype for the exchange of left/right boundaries.
+!-- Although data are contiguous in physical memory (which does not necessarily require an
+!-- MPI-derived datatype), the data exchange between left and right PE's using the MPI-derived type
+!-- is 10% faster than without.
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz(0), MPI_REAL, type_xz(0),     &
+                          ierr )
+    CALL MPI_TYPE_COMMIT( type_xz(0), ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz(0), ngp_yz(0), MPI_REAL, type_yz(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_yz(0), ierr )
+
+!
+!-- Define data types for exchange of 3D Integer arrays.
+    ngp_yz_int(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
+
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz_int(0), MPI_INTEGER,          &
+                          type_xz_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_xz_int(0), ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz_int(0), ngp_yz_int(0), MPI_INTEGER, type_yz_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_yz_int(0), ierr )
+
+!
+!-- Definition of MPI-datatypes for multigrid method (coarser level grids)
+    IF ( psolver(1:9) == 'multigrid' )  THEN
+!
+!--    Definition of MPI-datatyoe as above, but only 1 ghost level is used
+       DO  i = maximum_grid_level, 1 , -1
+!
+!--       For 3D-exchange on different multigrid level, one ghost point for REAL arrays, two ghost
+!--       points for INTEGER arrays
+          ngp_xz(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
+          ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
+
+          ngp_xz_int(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
+          ngp_yz_int(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
+!
+!--       MPI data type for REAL arrays, for xz-layers
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), MPI_REAL, type_xz(i),     &
+                                ierr )
+          CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
+
+!
+!--       MPI data type for INTEGER arrays, for xz-layers
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz_int(i), MPI_INTEGER,          &
+                                type_xz_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_xz_int(i), ierr )
+
+!
+!--       MPI data type for REAL arrays, for yz-layers
+          CALL MPI_TYPE_VECTOR( 1, ngp_yz(i), ngp_yz(i), MPI_REAL, type_yz(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_yz(i), ierr )
+!
+!--       MPI data type for INTEGER arrays, for yz-layers
+          CALL MPI_TYPE_VECTOR( 1, ngp_yz_int(i), ngp_yz_int(i), MPI_INTEGER, type_yz_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_yz_int(i), ierr )
+
+
+!--       For 2D-exchange of INTEGER arrays on coarser grid level, where 2 ghost points need to be
+!--       exchanged. Only required for 32-bit Integer arrays.
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+5, 2, nyn_l-nys_l+5, MPI_INTEGER, type_x_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_x_int(i), ierr )
+
+
+          CALL MPI_TYPE_VECTOR( 2, nyn_l-nys_l+5, nyn_l-nys_l+5, MPI_INTEGER, type_y_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_y_int(i), ierr )
+
+          nxl_l = nxl_l / 2
+          nxr_l = nxr_l / 2
+          nys_l = nys_l / 2
+          nyn_l = nyn_l / 2
+          nzt_l = nzt_l / 2
+
+       ENDDO
+
     ENDIF
 
@@ -1178,5 +1120,5 @@
 !-- Setting of flags for inflow/outflow/nesting conditions.
     IF ( pleft == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation'  .OR.  bc_lr == 'nested'  .OR.      &
+       IF ( bc_lr == 'dirichlet/radiation'  .OR.  bc_lr == 'nested'  .OR.                          &
             bc_lr == 'nesting_offline' )  THEN
           bc_dirichlet_l  = .TRUE.
@@ -1185,9 +1127,9 @@
        ENDIF
     ENDIF
- 
+
     IF ( pright == MPI_PROC_NULL )  THEN
        IF ( bc_lr == 'dirichlet/radiation' )  THEN
           bc_radiation_r = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet'  .OR.  bc_lr == 'nested'  .OR.  &
+       ELSEIF ( bc_lr == 'radiation/dirichlet'  .OR.  bc_lr == 'nested'  .OR.                      &
                 bc_lr == 'nesting_offline' )  THEN
           bc_dirichlet_r  = .TRUE.
@@ -1198,5 +1140,5 @@
        IF ( bc_ns == 'dirichlet/radiation' )  THEN
           bc_radiation_s = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet'  .OR.  bc_ns == 'nested'  .OR.  &
+       ELSEIF ( bc_ns == 'radiation/dirichlet'  .OR.  bc_ns == 'nested'  .OR.                      &
                 bc_ns == 'nesting_offline' )  THEN
           bc_dirichlet_s  = .TRUE.
@@ -1205,5 +1147,5 @@
 
     IF ( pnorth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation'  .OR.  bc_ns == 'nested'  .OR.      &
+       IF ( bc_ns == 'dirichlet/radiation'  .OR.  bc_ns == 'nested'  .OR.                          &
             bc_ns == 'nesting_offline' )  THEN
           bc_dirichlet_n  = .TRUE.
@@ -1213,7 +1155,7 @@
     ENDIF
 !
-!-- In case of synthetic turbulence geneartor determine ids. 
-!-- Please note, if no forcing or nesting is applied, the generator is applied
-!-- only at the left lateral boundary.
+!-- In case of synthetic turbulence geneartor determine ids.
+!-- Please note, if no forcing or nesting is applied, the generator is applied only at the left
+!-- lateral boundary.
     IF ( use_syn_turb_gen )  THEN
        IF ( bc_dirichlet_l )  THEN
@@ -1239,21 +1181,17 @@
 
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_left_l, id_stg_left,   1, MPI_INTEGER,       &
-                           MPI_SUM, comm1dx, ierr )
+       CALL MPI_ALLREDUCE( id_stg_left_l, id_stg_left,   1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
 
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_right_l, id_stg_right, 1, MPI_INTEGER,       &
-                           MPI_SUM, comm1dx, ierr )
+       CALL MPI_ALLREDUCE( id_stg_right_l, id_stg_right, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
 
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_south_l, id_stg_south, 1, MPI_INTEGER,       &
-                           MPI_SUM, comm1dy, ierr )
+       CALL MPI_ALLREDUCE( id_stg_south_l, id_stg_south, 1, MPI_INTEGER, MPI_SUM, comm1dy, ierr )
 
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_north_l, id_stg_north, 1, MPI_INTEGER,       &
-                           MPI_SUM, comm1dy, ierr )
-
-    ENDIF 
- 
+       CALL MPI_ALLREDUCE( id_stg_north_l, id_stg_north, 1, MPI_INTEGER, MPI_SUM, comm1dy, ierr )
+
+    ENDIF
+
 !
 !-- Broadcast the id of the inflow PE
@@ -1264,6 +1202,5 @@
     ENDIF
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( id_inflow_l, id_inflow, 1, MPI_INTEGER, MPI_SUM, &
-                        comm1dx, ierr )
+    CALL MPI_ALLREDUCE( id_inflow_l, id_inflow, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
 
 !
@@ -1271,5 +1208,5 @@
 !-- WARNING: needs to be adjusted in case of inflows other than from left side!
     IF ( turbulent_inflow ) THEN
-    
+
        IF ( NINT( recycling_width / dx, KIND=idp ) >= nxl  .AND.                                   &
             NINT( recycling_width / dx, KIND=idp ) <= nxr )  THEN
@@ -1279,7 +1216,6 @@
        ENDIF
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_recycling_l, id_recycling, 1, MPI_INTEGER, MPI_SUM, &
-                           comm1dx, ierr )
-                           
+       CALL MPI_ALLREDUCE( id_recycling_l, id_recycling, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
+
     ENDIF
 
@@ -1297,5 +1233,5 @@
                            comm1dx, ierr )
 
-       IF ( NINT( outflow_source_plane / dx ) >= nxl  .AND. &
+       IF ( NINT( outflow_source_plane / dx ) >= nxl  .AND.                                        &
             NINT( outflow_source_plane / dx ) <= nxr )  THEN
           id_outflow_source_l = myidx
@@ -1304,6 +1240,6 @@
        ENDIF
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_outflow_source_l, id_outflow_source, 1, &
-                           MPI_INTEGER, MPI_SUM, comm1dx, ierr )
+       CALL MPI_ALLREDUCE( id_outflow_source_l, id_outflow_source, 1, MPI_INTEGER, MPI_SUM,        &
+                           comm1dx, ierr )
 
     ENDIF
@@ -1330,6 +1266,5 @@
 
 !
-!-- At the inflow or outflow, u or v, respectively, have to be calculated for
-!-- one more grid point.
+!-- At the inflow or outflow, u or v, respectively, have to be calculated for one more grid point.
     IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
        nxlu = nxl + 1
